--HexSQL v1
--Written by Hexxeh/Amaroth

--Print message to show the script has started
_Msg("HexSQL: HexSQL has started.\n")

--Invoke SQL stuff
require"luasql.mysql"

--Use MD5 libary
_OpenScript("md5.lua")

--Print message to show MySQL has been loaded
_Msg("HexSQL: SQL libaries have been loaded.\n")

--Define function table
HexSQL = {}

--Define HexSQL version number to be shown ingame
HexSQL.VersionNumber = "0.1 Beta"

--Define server name to be used on GUI (  19 character maximum)
HexSQL.ServerName = "Hexxeh's Testing Server"

--Define MOTD to be used on GUI (  19 character maximum)
HexSQL.MOTD = "Your MOTD goes here."

--Define what forums we are using
HexSQL.Forums = "vBulletin"

--Define logged in users table
HexSQL.ForumUsers = {}

--Should we kick and ban banned users?
HexSQL.BannedUsersMode = 1

--How long should banned users been kicked and banned for in minutes?
HexSQL.BannedUsersLength = 30

--Should we force new clients to logon to the forums?
HexSQL.ForceLogon = 1

--Define required downloads table
HexSQL.requiredFiles = {}

--Print message to show that tables were created
_Msg("HexSQL: HexSQL tables created.\n")

--Setup DB details
HexSQL.IP = "YOUR MYSQL ADDRESS"
HexSQL.DB = "YOUR DB NAME"
HexSQL.User = "YOUR MYSQL USER"
HexSQL.Password = "YOUR MYSQL PASSWORD"

--Print message to show that DB info was present
_Msg("HexSQL: Database connection info present.\n")

function HexSQL:Connect()
	env = assert (luasql.mysql()) --Open LuaSQL MySQL environment as new object 'env'
	con = assert (env:connect(HexSQL.DB, HexSQL.User, HexSQL.Password, HexSQL.IP)) --Open connection to a MySQL database
end

function HexSQL:Disconnect()
	con:close()
	env:close()
end

function HexSQL:CreateDatbase(database)
	local query = "CREATE DATABASE " .. database
	local result = assert (con:execute(query))
	return result
end

function HexSQL:CreateTable(tablename,vars)
	local query = "CREATE TABLE " .. tablename .. "\n (\n" .. vars .. "\n)"
	local result = assert (con:execute(query))
	return result
end

function HexSQL:SetData(target,values)
	local query = "INSERT INTO " .. target .. " VALUES (" .. values .. ")"
	local result = assert (con:execute(query))
	return result
end

function HexSQL:UpdateData(target,id, value,newvalue)
	local query = "UPDATE " .. target .. " SET " .. id .. "='" .. newvalue .. "' WHERE " .. id .. " = '" .. value .. "'"
	local result = assert (con:execute(query))
	return result
end

function HexSQL:GetData(target,id,value,requiredcell)
	if requiredcell == nil then
		query = "SELECT * FROM " .. target .. " WHERE " .. id .. " = '" .. value .. "'"
	else
		query = "SELECT " .. requiredcell .. " FROM " .. target .. " WHERE " .. id .. " = '" .. value .. "'"
	end
	local cur = assert (con:execute(query))
	local result = cur:fetch()
	return result
end

function HexSQL:RemoveData(target,id,value)
	local query = "DELETE FROM " .. target .. " WHERE " .. id .. " = '" .. value .. "'"
	local result = assert (con:execute(query))
	return result
end

function HexSQL:SendRawSQL(query)
	local result = assert (con:execute(query))
	return result
end

--Forum logon codes
function HexSQL.phpBBLogin(userid,args)
	if HexSQL.Forums == "phpBB" then
		HexSQL:Connect()
		local auth = explode(" ",args)
		passwordfromdb = HexSQL:GetData("phpbb_users","username",auth[1],"user_password")
		if passwordfromdb == nil then
			_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Incorrect username or password for logging into phpBB.\n")
			_Msg("HexSQL: A phpBB user failed to logon.\n")
		else
			if passwordfromdb == md5.sumhexa(auth[2]) then
				forums_user_id = HexSQL:GetData("phpbb_users","username",auth[1],"user_id")
				checkban = HexSQL:GetData("phpbb_banlist","ban_userid",forums_user_id)
				if checkban == nil then
					HexSQL.ForumUsers[userid].LoggedIn = 1
					_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Logged into phpBB sucessfully.\n")
					_Msg("HexSQL: A phpBB user logged on.\n")
					if HexSQL.ForumUsers[userid].NotLoggedIn == 1 then
						local username = auth[1]
						HexSQL.ForumUsers[userid].NotLoggedIn = 0
						HexSQL.PlayerLoggedIn(userid,username)
					end
				else
					_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: The account specified is banned.\n")
					_Msg("HexSQL: A banned phpBB user tried to logon.\n")
					if HexSQL.BannedUsersMode == 1 then
						_ServerCommand("banid " .. HexSQL.BannedUsersLength .. " " .. _PlayerInfo(userid,"networkid") .. "\n")
						_ServerCommand("kick " .. _PlayerInfo(userid,"name") .. "\n")
						_Msg("HexSQL: A banned phpBB user was kicked and banned for " .. HexSQL.BannedUsersLength .. " minutes.\n")
					end
				end
			else
				_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Incorrect username or password for logging into phpBB.\n")
				_Msg("HexSQL: A phpBB user failed to logon.\n")
			end
		end
		HexSQL:Disconnect()
	else
	_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: This server isn't linked to a phpBB forum. It's conencted to a " .. HexSQL.Forums .. " forum. Please use the command hexsql_" .. string.lower(HexSQL.Forums) .. "login <Username> <Password>\n")
	_Msg("HexSQL: A user tried to logon with the wrong command. Consider enabling stealthing mode.")
	end
end
CONCOMMAND("hexsql_phpbblogin",HexSQL.phpBBLogin)

function HexSQL.vBulletinLogin(userid,args)
	if HexSQL.Forums == "vBulletin" then
	HexSQL:Connect()
	local auth = explode(" ",args)
	passwordfromdb = HexSQL:GetData("user","username",auth[1],"password")
	if passwordfromdb == nil then
		_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Incorrect username or password for logging into vBulletin\n")
		_Msg("HexSQL: A vBulletin user failed to logon.\n")
	else
		saltfromdb = HexSQL:GetData("user","username",auth[1],"salt")
		forums_user_id = HexSQL:GetData("user","username",auth[1],"userid")
		salthashed = md5.sumhexa(md5.sumhexa(auth[2])..saltfromdb)
		if passwordfromdb == salthashed then
			checkban = HexSQL:GetData("userban","userid",forums_user_id)
			if checkban == nil then
				HexSQL.ForumUsers[userid].LoggedIn = 1
				_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Logged into vBulletin sucessfully.\n")
				_Msg("HexSQL: A vBulletin user logged on.\n")
				local username = auth[1]
				HexSQL.PlayerLoggedIn(userid,username)
			else
				_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: The account specified is banned.\n")
				_Msg("HexSQL: A banned vBulletin user tried to logon.\n")
				if HexSQL.BannedUsersMode == 1 then
					forumbanreason = HexSQL:GetData("userban","userid",forums_user_id,"reason")
					if forumbanreason == nil then forumbanreason = "You are banned from the forums. Get out." end
					_ServerCommand("banid " .. HexSQL.BannedUsersLength .. " " .. _PlayerInfo(userid,"networkid") .. "\n")
					_ServerCommand("kickid " .. _PlayerInfo(userid,"networkid") .. " \"" .. forumbanreason .. "\"\n")
					_Msg("HexSQL: A banned vBulletin user was kicked and banned for " .. HexSQL.BannedUsersLength .. " minutes.\n")
				end
			end
		else
			_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: Incorrect username or password for logging into vBulletin.\n")
			_Msg("HexSQL: A vBulletin user failed to logon.\n")
		end
	end
	HexSQL:Disconnect()
	else
	_PrintMessage(userid,HUD_PRINTCONSOLE,"HexSQL: This server isn't linked to a vBulletin forum. It's conencted to a " .. HexSQL.Forums .. " forum. Please use the command hexsql_" .. string.lower(HexSQL.Forums) .. "login <Username> <Password>\n")
	_Msg("HexSQL: A user tried to logon with the wrong command. Consider enabling stealthing mode.")
	end
end
CONCOMMAND("hexsql_vbulletinlogin",HexSQL.vBulletinLogin)

--Remove login screen once logged in
function HexSQL.PlayerLoggedIn(userid,username)
	for i=0, 17 do
		_GModText_Start("Default")
		_GModText_SetPos(0, 0)
		_GModText_SetTime(1, 0, 1)
		_GModText_SetText("")
		_GModText_SetColor(255, 255, 255, 0)
		_GModText_Send(userid, i)	
	end
	_GModRect_Start("gmod/white")
	_GModRect_SetPos(0, 0, 1, 1)
	_GModRect_SetColor(255, 255, 255, 0)
	_GModRect_SetTime(1, 0, 0)
	_GModRect_Send(userid, 1)
	_PlayerFreeze(userid,false)
	_Msg("HexSQL: Cleared screen for a user.\n")
end

--Add our required stuff for the script to res files
function HexSQL.AddDownload(filename)
	if HexSQL.isValid(filename,"string")==false then return _Msg("HexSQL: AddDownload arguments invalid.\n") end
	table.insert(HexSQL.requiredFiles,table.getn(HexSQL.requiredFiles),filename)
end

function HexSQL.SaveDownloads()
	local fullString="";
	if _file.Exists("maps/".._GetCurrentMap()..".res") then
		fullString=_file.Read("maps/".._GetCurrentMap()..".res")
		fullString=string.gsub(fullString,"}","");
	else
		fullString="\"resources\"\n{\n";
	end
	local filenames=HexSQL.requiredFiles
	for key,value in filenames do
		if string.find(string.lower(fullString),string.lower(value))==nil then
			fullString=fullString.."\""..value.."\" \"file\"\n"
		end
	end
	fullString=fullString.."}"
	_file.Write("maps/".._GetCurrentMap()..".res",fullString)
end

function HexSQL.isValid(value,reqType)
	if type(value)~="nil" then
		if reqType~=nil then
			if type(value)==string.lower(reqType) then
				return true
			else
				return false
			end
		else
			return true
		end
	else
		return false
	end
end

--Aux function for splitting args
function explode(d,p)
	local t,ll,l
	t={}
	ll=0
	while true do
		l=string.find(p,d,ll+1,true) -- find the next d in the string
		if l~=nil then -- if "not not" found then..
			table.insert(t, string.sub(p,ll,l-1)) -- Save it in our array.
			ll=l+1 -- save just after where we found it for searching next time.
		else
			table.insert(t, string.sub(p,ll)) -- Save what's left in our array.
			break -- Break at end, as it should be, according to the lua manual.
		end
	end
	return t
end

--Hooks
if HexSQL.ForceLogon == 1 then 
	function HexSQL.ForceLoginOnConnect(name,userid,steamid)
		_PlayerFreeze(userid,true)
		--Draw login screen background
		_GModRect_Start("hexsql/loginscreen")
		_GModRect_SetPos(0, 0, 1, 1.35)
		_GModRect_SetColor(25, 25, 25, 255)
		_GModRect_SetTime(9999, 0, 1)
		_GModRect_Send(userid, 1)
		--Put texts on screen
		_GModText_Start("HudHintTextLarge")
		_GModText_SetPos(0.06, 0.02)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("HexSQL version " .. HexSQL.VersionNumber)
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 1)
		_GModText_Start("ImpactMassive")
		_GModText_SetPos(0.34, 0.07)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("Welcome to " .. HexSQL.ServerName .. "!")
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 2)
		_GModText_Start("Default")
		_GModText_SetPos(0.04, 0.1)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("HexSQL update news:")
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 3)
		_GModText_Start("DefaultSmall")
		_GModText_SetPos(0.04, 0.12)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("First versions are in testing on this\nserver. Don't complain if the server\ngoes down or whatever. ~Hexxeh")
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 4)
		_GModText_Start("DefaultSmall")
		_GModText_SetPos(0.35, 0.14)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText(HexSQL.MOTD)
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 5)
		_GModText_Start("Default")
		_GModText_SetPos(0.04, 0.38)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("Login Instructions:")
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 6)
		_GModText_Start("DefaultSmall")
		_GModText_SetPos(0.04, 0.4)
		_GModText_SetTime(9999, 0, 1)
		if HexSQL.Forums == "phpBB" then
			_GModText_SetText("To login to this server use the\nfollowing console command:")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 7)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.09, 0.46)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("hexsql_phpbblogin")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 8)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.5)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 9)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.1175, 0.54)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Space>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 10)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.58)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 11)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.11, 0.62)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Username>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 12)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.66)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 13)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.1175, 0.70)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Space>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 14)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.74)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 15)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.11, 0.78)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Password>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 16)
		elseif HexSQL.Forums == "vBulletin" then
			_GModText_SetText("To login to this server use the\nfollowing console command:")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 7)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.09, 0.46)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("hexsql_vbulletinlogin")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 8)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.5)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 9)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.1175, 0.54)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Space>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 10)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.58)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 11)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.11, 0.62)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Username>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 12)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.66)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 13)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.1175, 0.70)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Space>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 14)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.145, 0.74)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("+")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 15)
			_GModText_Start("DefaultSmall")
			_GModText_SetPos(0.11, 0.78)
			_GModText_SetTime(9999, 0, 1)
			_GModText_SetText("<Password>")
			_GModText_SetColor(255, 255, 255, 255)
			_GModText_Send(userid, 16)
		end
		_GModText_Start("CreditsText")
		_GModText_SetPos(0.25, 0.97)
		_GModText_SetTime(9999, 0, 1)
		_GModText_SetText("HexSQL v0.1 Beta by Hexxeh. Don't take as your own. Use on as many servers as you like.")
		_GModText_SetColor(255, 255, 255, 255)
		_GModText_Send(userid, 17)
		HexSQL.ForumUsers[userid] = {}
		HexSQL.ForumUsers[userid].LoggedIn = 0
	end
	HookEvent("eventPlayerActive", HexSQL.ForceLoginOnConnect)
end

--Hook to remove users that leave from the logged in users table. Stops account hijacking.
function HexSQL.RemoveLoggedInUser(name,userid,address,steamid,reason)
	HexSQL.ForumUsers[userid].LoggedIn = 0
end
HookEvent("eventPlayerDisconnect", HexSQL.RemoveLoggedInUser)

--Print message to show that all functions were defined
_Msg("HexSQL: All functions loaded correctly.\n")

--MD5 hasher test
function testMD5(userid,args)
	_Msg(md5.sumhexa(args) .. "\n")
	_PrintMessage(userid,HUD_PRINTCONSOLE,md5.sumhexa(args) .. "\n")
	args = nil
end
CONCOMMAND("md5",testMD5)

--Add our required downloads
HexSQL.AddDownload("materials/hexsql/loginscreen.vtf")
HexSQL.AddDownload("materials/hexsql/loginscreen.vmt")
HexSQL.SaveDownloads()
_Msg("HexSQL: All required downloads added.\n")
